﻿'
' SharpDevelopによって生成
' ユーザ: とど
' 日付: 09/12/2014
' 時刻: 21:29
' 
' このテンプレートを変更する場合「ツール→オプション→コーディング→標準ヘッダの編集」
'
Imports System.Drawing.Printing
Imports System.Drawing
Imports System.Drawing.Drawing2D
Imports System.Drawing.Imaging
''' <summary>
''' ﾃﾞｰﾀｸﾞﾘｯﾄﾞﾋﾞｭｰを印刷するｸﾗｽです
''' </summary>
Public Class clsDataGridViewPrinter
	
	#Region "ﾌﾟﾗｲﾍﾞｰﾄ変数"
	''' <summary>
	''' 印刷ﾄﾞｷｭﾒﾝﾄ
	''' </summary>
	Private WithEvents m_objPrinterDoc As New PrintDocument
	''' <summary>
	''' 印刷ﾌﾟﾚﾋﾞｭｰﾀﾞｲｱﾛｸﾞ
	''' </summary>
	Private m_objPrintPreview As PrintPreviewDialog
	''' <summary>
	''' 印刷対象のDataGridView
	''' </summary>
	Private m_objGrid As DataGridView
	''' <summary>
	''' 列幅の総和
	''' </summary>
	Private m_intWidth As Integer
	''' <summary>
	''' 現在印刷中のﾍﾟｰｼﾞ
	''' </summary>
	Private m_intNowPage As Integer
	''' <summary>
	''' 描画中の列ｲﾝﾃﾞｯｸｽ
	''' </summary>
	Private m_intIndx As Integer
	''' <summary>
	''' 表本体のﾌｫﾝﾄ
	''' </summary>
	Private m_fntFont As Font
	''' <summary>
	''' ﾍｯﾀﾞのﾌｫﾝﾄ
	''' </summary>
	Private m_fntHeader As Font
	''' <summary>
	''' ｾﾙの枠線
	''' </summary>
	Private m_penCell As Pen
	''' <summary>
	''' 印刷ﾌﾟﾚﾋﾞｭｰﾀﾞｲｱﾛｸﾞのｱｲｺﾝ
	''' </summary>
	Private m_icoPreview As Icon
	''' <summary>
	''' 上のｾﾙと値が同じ時はｾﾙを合体するための指定文字列
	''' </summary>
	Private m_strJointUpperCell As String 
	''' <summary>
	''' 上のｾﾙと値が同じ時はｾﾙを合体するﾘｽﾄ
	''' </summary>
	Private m_lisJointUpperCell As New List(Of String)
	
	''' <summary>
	''' ｶﾗｰで描画
	''' </summary>
	Private m_blDrawColor As Boolean =False
	''' <summary>
	''' 幅方向の拡大率をMAX1倍までに制限
	''' </summary>
	Private m_blLimitMaxSize As Boolean =True
	
	#End Region
	
	#Region"ﾊﾟﾌﾞﾘｯｸﾌﾟﾛﾊﾟﾃｨ"
	''' <summary>
	''' 幅方向の拡大率をMAX1倍までに制限
	''' </summary>
	Public Property LimitMaxSize() As Boolean
		Get
			Return m_blLimitMaxSize
		End Get
		Set
			m_blLimitMaxSize = value
		End Set
	End Property
	''' <summary>
	''' ｶﾗｰで描画
	''' </summary>
	Public Property DrawColor() As Boolean
		Get
			Return m_blDrawColor
		End Get
		Set
			m_blDrawColor = value
		End Set
	End Property
	''' <summary>
	''' 上のｾﾙと値が同じ時はｾﾙを合体させる列をｶﾝﾏ区切りで指定します
	''' </summary>
	Public Property JointUpperCell() As String
		Get
			Return m_strJointUpperCell
		End Get
		Set
			Dim rg As New System.Text.RegularExpressions.Regex("^\d+(,\d+)*$")
			If rg.Match(value).Success Then
				m_strJointUpperCell = value
				m_lisJointUpperCell.Clear
				m_lisJointUpperCell.AddRange(value.Split(","c))
			End If
		End Set
	End Property
	''' <summary>
	''' 印刷ﾌﾟﾚﾋﾞｭｰﾀﾞｲｱﾛｸﾞのｱｲｺﾝ
	''' </summary>
	Public Property PreviewDialogIcon() As Icon
		Get
			Return m_icoPreview
		End Get
		Set
			m_icoPreview = value
		End Set
	End Property
	''' <summary>
	''' ﾍｯﾀﾞのﾌｫﾝﾄ
	''' </summary>
	Public Property HeaderFont() As Font
		Get
			Return m_fntHeader
		End Get
		Set
			m_fntHeader = value
		End Set
	End Property
	''' <summary>
	''' 表本体のﾌｫﾝﾄ
	''' </summary>
	Public Property [Font]() As Font
		Get
			Return m_fntFont
		End Get
		Set
			m_fntFont = value
		End Set
	End Property
	''' <summary>
	''' ｾﾙの枠線
	''' </summary>
	Public Property PenCell() As Pen
		Get
			Return m_penCell
		End Get
		Set
			m_penCell = value
		End Set
	End Property
	#End Region
	
	#Region"ﾊﾟﾌﾞﾘｯｸｲﾍﾞﾝﾄ"
	Public Event BeforePrintPage(Byref sender As Object,Byref e As clsDataGridViewPrinter.BeforePrintPageEventArgs)
	
	#End Region
	
	#Region"ﾊﾟﾌﾞﾘｯｸ関数"
	''' <summary>
	''' ｺﾝｽﾄﾗｸﾀ
	''' </summary>
	''' <param name="GridView">印刷対象のDataGridView</param>
	Sub New(ByVal GridView As DataGridView)	
		With m_objPrinterDoc.PrinterSettings.DefaultPageSettings.Margins
			.Left=50
			.Top=50
			.Right=50
			.Bottom=50
		End With
		m_objPrinterDoc.DefaultPageSettings=m_objPrinterDoc.PrinterSettings.DefaultPageSettings
		
		m_objGrid=GridView
		m_fntFont=New Font("ＭＳ Ｐ明朝",1)
		m_fntHeader=New Font("ＭＳ Ｐゴシック",1)
		AddHandler m_objPrinterDoc.BeginPrint,AddressOf m_objPrinterDoc_BeginPrint
		AddHandler m_objPrinterDoc.EndPrint,AddressOf m_objPrinterDoc_EndPrint
		AddHandler m_objPrinterDoc.PrintPage,AddressOf m_objPrinterDoc_PrintPage
	End Sub
	''' <summary>
	''' ﾌﾟﾘﾝﾀ設定を行います
	''' </summary>
	Public Sub PrinterSetting
		m_subPrint(False)
	End Sub
	''' <summary>
	''' ﾍﾟｰｼﾞ設定を行います
	''' </summary>
	Public Sub PageSetting
		Dim ps As PageSettings=CType(m_objPrinterDoc.DefaultPageSettings.Clone,PageSettings)
		Dim frmPageSetting As New PageSetupDialog
		frmPageSetting.PageSettings=ps
		frmPageSetting.EnableMetric=True
		
		If frmPageSetting.ShowDialog=DialogResult.OK Then
			m_objPrinterDoc.DefaultPageSettings=frmPageSetting.PageSettings
		End If
	End Sub
	''' <summary>
	'''　印刷します
	''' </summary>
	Public Sub Print(Optional Byval DocumentName As String="ﾃﾞｰﾀ表")
		Try
			m_subPrint(True,DocumentName)	
		Catch ex As Exception
			MsgBox("処理中にｴﾗｰｶﾞ発生しました。" & ControlChars.CrLf & ex.Message, MsgBoxStyle.Critical,"ｴﾗｰ")
		End Try
		
	End Sub
	''' <summary>
	''' 印刷ﾌﾟﾚﾋﾞｭｰします
	''' </summary>
	Public Sub Preview(Optional ByVal DocumentName As String="ﾃﾞｰﾀ表")
		m_objPrinterDoc.DocumentName=DocumentName
		Try
			m_objPrintPreview=New PrintPreviewDialog
			With m_objPrintPreview
				.Icon=m_icoPreview
				.Document=m_objPrinterDoc
				.StartPosition=FormStartPosition.CenterScreen
				.Height=CInt(Screen.PrimaryScreen.WorkingArea.Height*0.8)
				.Width=CInt(.Height/1.41421356)
			End With
			m_objPrintPreview.ShowDialog
			m_objPrintPreview.Dispose
		Catch ex As Exception
			MsgBox("処理中にｴﾗｰｶﾞ発生しました。" & ControlChars.CrLf & ex.Message, MsgBoxStyle.Critical,"ｴﾗｰ")
		End Try
	End Sub
	
	''' <summary>
	''' Bitﾏｯﾌﾟとして印刷ﾍﾟｰｼﾞを受け取ります
	''' </summary>
	''' <param name="PicWidth">ﾋﾞｯﾄﾏｯﾌﾟ(ﾍﾟｰｼﾞ)の幅</param>
	''' <param name="PicHeight">ﾋﾞｯﾄﾏｯﾌﾟ(ﾍﾟｰｼﾞ)の高さ</param>
	''' <param name="Resolution">解像度dpi</param>
	''' <returns></returns>
	Public Function GetPictrues(Byval PicWidth As Integer,Byval PicHeight As Integer,Optional Byval Resolution As Integer=300) As List(Of Bitmap)
		'Pre
		'印刷開始時に各種変数を初期化
		m_intWidth=0
		m_intNowPage=0
		m_intIndx=0
		Dim clm As DataGridViewColumn
		For Each clm In m_objGrid.Columns
			m_intWidth+=clm.Width	
		Next
		
		'Print
		
		Dim retLis As New List(Of Bitmap)
		Dim hasmorepages As Boolean
		
		If m_objGrid.Rows.Count=0 Then Return Nothing
		
		
		Dim i As Integer
		Dim sumx As Single
		Dim sumy As Single
		Dim fstrw As Boolean  	
		Dim clrct As RectangleF
		Dim txrct As RectangleF
		Dim bmp As Bitmap
		Dim e As Graphics
		Dim myPen As Pen
		
		If m_penCell Is Nothing Then
			myPen=New Pen(Color.Black,3)
		Else
			myPen=m_penCell
		End If
		
		
		'loop
		Do
			i=0
			sumx=0
			sumy=0
			fstrw=True
			bmp = New Bitmap(PicWidth,PicHeight)
			bmp.SetResolution(Resolution,Resolution)
			e=Graphics.FromImage(bmp)
			e.Clear(Color.White)
			m_intNowPage+=1
			
			'画質
			e.PixelOffsetMode=PixelOffsetMode.Half
			e.SmoothingMode=SmoothingMode.AntiAlias
			
			
			'縮尺
			Dim rt As Double=PicWidth/m_intWidth
			If m_blLimitMaxSize Then
				If rt>1 Then
					rt=1
				End If
			End If
			
			Dim hcnt As Single=CSng(PicHeight)
			
			'ﾍｯﾀﾞ印刷
			For i=0 To m_objGrid.Columns.Count-1
				clrct=New RectangleF(sumx,sumy,CSng(m_objGrid.Columns(i).Width*rt),CSng(m_objGrid.ColumnHeadersHeight*rt))
				txrct=New RectangleF(CSng(clrct.Left+clrct.Width*0.01),CSng(clrct.Top+clrct.Height*0.01),clrct.Width,clrct.Height)
				Dim t As String = m_objGrid.Columns(i).HeaderText
				Dim f As Font=m_fncGetJustFont(e,m_fntHeader,t,New SizeF(clrct.Width,clrct.Height))
				Dim sfh As New StringFormat
				Dim csh As  DataGridViewContentAlignment=m_objGrid.Columns(i).HeaderCell.Style.Alignment
				If csh=DataGridViewContentAlignment.NotSet Then
					csh=m_objGrid.ColumnHeadersDefaultCellStyle.Alignment
				End If
				sfh.LineAlignment=StringAlignment.Center
				Select Case csh
					Case DataGridViewContentAlignment.BottomLeft,DataGridViewContentAlignment.MiddleLeft,DataGridViewContentAlignment.TopLeft
						sfh.Alignment=StringAlignment.Near
					Case DataGridViewContentAlignment.BottomCenter,DataGridViewContentAlignment.MiddleCenter,DataGridViewContentAlignment.TopCenter
						sfh.Alignment=StringAlignment.Center
					Case DataGridViewContentAlignment.BottomRight,DataGridViewContentAlignment.MiddleRight,DataGridViewContentAlignment.TopRight
						sfh.Alignment=StringAlignment.Far
				End Select	
				
				With e
					If m_blDrawColor Then
						Dim hdc As Color=m_objGrid.Columns(i).HeaderCell.Style.BackColor
						Dim hdtc As Color=m_objGrid.Columns(i).HeaderCell.Style.ForeColor
						If hdc=Color.Empty Then
							hdc=m_objGrid.ColumnHeadersDefaultCellStyle.BackColor
						End If
						If hdtc=Color.Empty Then
							hdtc=m_objGrid.ColumnHeadersDefaultCellStyle.ForeColor
						End If
						'ｶﾗｰ四角を書く
						.FillRectangle(New SolidBrush(hdc),CSng(clrct.Left),CSng(clrct.Top),CSng(clrct.Width),CSng(clrct.Height))
						'ｶﾗｰﾍｯﾀﾞ文字を書く
						.DrawString(t,f,New SolidBrush(hdtc),clrct,sfh)
					Else
						'ﾍｯﾀﾞ文字を書く
						.DrawString(t,f,Brushes.Black,txrct,sfh)
					End If
					'枠を書く
					.DrawRectangle(myPen,clrct.Left,clrct.Top,clrct.Width,txrct.Height)	
				End With
				sumx+=clrct.Width
			Next
			
			'1行分高さを消費
			sumy+=clrct.Height
			
			Do
				If m_intIndx<m_objGrid.Rows.Count Then
					Dim rh As Single=CSng(Int(m_objGrid.Rows(m_intIndx).Height*rt))
					Dim nflg As Boolean
					Dim tflg As Boolean
					If m_intIndx<m_objGrid.Rows.Count-1 AndAlso sumy+rh+CSng(Int(m_objGrid.Rows(m_intIndx+1).Height*rt))>hcnt Then
						nflg=True
					Else
						nflg=False
					End If
					If sumy+rh>hcnt Then
						hasMorePages=True
						Exit Do
					Else
						'各ｾﾙを印刷
						sumx=0
						For i=0 To m_objGrid.Columns.Count-1
							clrct=New RectangleF(sumx,sumy,CSng(m_objGrid.Columns(i).Width*rt),CSng(m_objGrid.Rows(m_intIndx).Height*rt))
							txrct=New RectangleF(CSng(clrct.Left+clrct.Width*0.01),CSng(clrct.Top+clrct.Height*0.01),clrct.Width,clrct.Height)
							With e 
								.PixelOffsetMode=Drawing2D.PixelOffsetMode.Half
								.SmoothingMode=Drawing2D.SmoothingMode.AntiAlias
								'四角を書く
								
								'BackColor
								If m_blDrawColor Then
									Dim cc As Color = m_objGrid.Rows(m_intIndx).Cells(i).Style.BackColor
									If cc=Color.Empty Then
										cc=m_objGrid.Rows(m_intIndx).DefaultCellStyle.BackColor
										If cc=Color.Empty Then
											cc=m_objGrid.DefaultCellStyle.BackColor
										End If
									End If
									.FillRectangle(New SolidBrush(cc),CInt(clrct.Left),CInt(clrct.Top),CInt(clrct.Width),CInt(clrct.Height))
								End If
								'１）上の線
								If m_lisJointUpperCell.Contains((i+1).ToString)=False OrElse fstrw OrElse m_intIndx=0 OrElse _
									IsNothing(m_objGrid.Rows(m_intIndx-1).Cells(i).Value) OrElse _
									IsNothing(m_objGrid.Rows(m_intIndx).Cells(i).Value) OrElse _
									m_objGrid.Rows(m_intIndx-1).Cells(i).Value.ToString<>m_objGrid.Rows(m_intIndx).Cells(i).Value.ToString Then
									.DrawLine(myPen,clrct.Left,clrct.Top,clrct.Left+clrct.Width,clrct.Top)
									tflg=True
								Else
									tflg=False
								End If
								'２）左の線
								.DrawLine(myPen,clrct.Left,clrct.Top,clrct.Left,clrct.Top+clrct.Height+CSng(0.5))
								'３）右の線
								.DrawLine(myPen,clrct.Left+clrct.Width,clrct.Top,clrct.Left+clrct.Width,clrct.Top+clrct.Height+CSng(0.5))
								'４）下の線
								If m_lisJointUpperCell.Contains((i+1).ToString)=False OrElse nflg=True OrElse m_intIndx=m_objGrid.Rows.Count-1 OrElse _
									IsNothing(m_objGrid.Rows(m_intIndx).Cells(i).Value) OrElse _
									IsNothing(m_objGrid.Rows(m_intIndx+1).Cells(i).Value) OrElse _
									m_objGrid.Rows(m_intIndx).Cells(i).Value.ToString<>m_objGrid.Rows(m_intIndx+1).Cells(i).Value.ToString Then
									.DrawLine(myPen,clrct.Left,clrct.Top+clrct.Height,clrct.Left+clrct.Width,clrct.Top+clrct.Height)						
								End If
								
								If IsNothing(m_objGrid.Rows(m_intIndx).Cells(i).Value)=False Then
									Dim t As String = m_objGrid.Rows(m_intIndx).Cells(i).Value.ToString
									Dim f As Font=m_fncGetJustFont(e,m_fntFont,t,New SizeF(clrct.Width,clrct.Height))
									Dim sf As New StringFormat
									Dim cs As  DataGridViewContentAlignment=m_objGrid.Rows(m_intIndx).Cells(i).Style.Alignment
									If cs=DataGridViewContentAlignment.NotSet Then
										cs=m_objGrid.Columns(i).DefaultCellStyle.Alignment
									End If
									sf.LineAlignment=StringAlignment.Center
									Select Case cs
										Case DataGridViewContentAlignment.BottomLeft,DataGridViewContentAlignment.MiddleLeft,DataGridViewContentAlignment.TopLeft
											sf.Alignment=StringAlignment.Near
										Case DataGridViewContentAlignment.BottomCenter,DataGridViewContentAlignment.MiddleCenter,DataGridViewContentAlignment.TopCenter
											sf.Alignment=StringAlignment.Center
										Case DataGridViewContentAlignment.BottomRight,DataGridViewContentAlignment.MiddleRight,DataGridViewContentAlignment.TopRight
											sf.Alignment=StringAlignment.Far
									End Select
									
									'文字を書く
									If tflg Then
										'									Dim drct As New RectangleF(clrct.Left,clrct.Top+clrct.Height/2-f.SizeInPoints/2-2,clrct.Width,clrct.Height)
										If m_blDrawColor Then
											Dim ctc As Color =m_objGrid.Rows(m_intIndx).Cells(i).Style.ForeColor
											If ctc=Color.Empty Then
												ctc=m_objGrid.Rows(m_intIndx).DefaultCellStyle.ForeColor
												If ctc=Color.Empty Then
													ctc=m_objGrid.DefaultCellStyle.ForeColor
												End If
											End If
											.DrawString(t,f,New SolidBrush(ctc),txrct,sf)
										Else
											.DrawString(t,f,Brushes.Black,txrct,sf)
										End If
									End If
								End If
								
							End With
							sumx+=clrct.Width
						Next
						sumy+=clrct.Height
						m_intIndx+=1
					End If
				Else
					hasMorePages=False
					Exit Do
				End If
				fstrw=False
			Loop  
			retLis.Add(bmp)
		Loop While hasmorepages
		'Post
		Return retLis
	End Function
	#End Region
	
	#Region "ﾌﾟﾗｲﾍﾞｰﾄ関数"
	#Region "ｲﾍﾞﾝﾄﾊﾝﾄﾞﾗ"
	''' <summary>
	''' ﾌﾟﾘﾝﾄ開始ｲﾍﾞﾝﾄﾊﾝﾄﾞﾗ
	''' </summary>
	''' <param name="sender"></param>
	''' <param name="e"></param>
	Private Sub m_objPrinterDoc_BeginPrint(sender As Object,e As System.Drawing.Printing.PrintEventArgs)
		'印刷開始時に各種変数を初期化
		m_intWidth=0
		m_intNowPage=0
		m_intIndx=0
		Dim clm As DataGridViewColumn
		For Each clm In m_objGrid.Columns
			m_intWidth+=clm.Width	
		Next
	End Sub
	''' <summary>
	''' ﾌﾟﾘﾝﾄ終了ｲﾍﾞﾝﾄﾊﾝﾄﾞﾗ
	''' </summary>
	Private Sub	m_objPrinterDoc_EndPrint(sender As Object, e As System.Drawing.Printing.PrintEventArgs)
		If e.PrintAction=Printing.PrintAction.PrintToPrinter Then 
			m_objPrintPreview.Hide
		End If
	End Sub
	''' <summary>
	''' ﾌﾟﾘﾝﾄﾍﾟｰｼﾞｲﾍﾞﾝﾄﾊﾝﾄﾞﾗ
	''' </summary>
	Private Sub m_objPrinterDoc_PrintPage(sender As Object,e As System.Drawing.Printing.PrintPageEventArgs)
		Dim i As Integer
		Dim sumx As Single
		Dim sumy As Single
		Dim fstrw As Boolean =True	
		Dim clrct As RectangleF
		Dim txrct As RectangleF
		Dim myPen As Pen
		
		If m_penCell Is Nothing Then
			myPen=New Pen(Color.Black,3)
		Else
			myPen=m_penCell
		End If
		
		If m_objGrid.Rows.Count=0 Then Exit Sub
		
		m_intNowPage+=1
		
		'BeforePritPageｲﾍﾞﾝﾄ発動
		Dim bfargs As New BeforePrintPageEventArgs(e.Graphics,e.MarginBounds,e.PageBounds,e.PageSettings,m_intNowPage)
		
		RaiseEvent BeforePrintPage(Me,bfargs)
		
		
		'画質
		e.Graphics.PixelOffsetMode=PixelOffsetMode.Half
		e.Graphics.SmoothingMode=SmoothingMode.AntiAlias
		
		'オフセット
		e.Graphics.TranslateTransform(CSng(e.MarginBounds.Left),CSng(e.MarginBounds.Top))
		'縮尺
		Dim rt As Double=e.MarginBounds.Width/m_intWidth
		If m_blLimitMaxSize Then
			If rt>1 Then
				rt=1
			End If
		End If
		
		Dim hcnt As Single=CSng(e.MarginBounds.Height)
		'ﾕｰｻﾞよってVirticalStartPositionがｾｯﾄされていたら印刷開始位置をずらす
		If bfargs.VirticalStartPosition>e.MarginBounds.Top Then
			sumy=bfargs.VirticalStartPosition-e.MarginBounds.Top
		End If
		'ﾕｰｻﾞによってVirticalEndPositionがｾｯﾄされていたら印刷終了位置をずらす
		If bfargs.VirticalEndPosition<e.MarginBounds.Bottom Then
			hcnt-=e.MarginBounds.Bottom-bfargs.VirticalEndPosition
		End If
		
		
		'ﾍｯﾀﾞ印刷
		For i=0 To m_objGrid.Columns.Count-1
			clrct=New RectangleF(sumx,sumy,CSng(m_objGrid.Columns(i).Width*rt),CSng(m_objGrid.ColumnHeadersHeight*rt))
			txrct=New RectangleF(CSng(clrct.Left+clrct.Width*0.01),CSng(clrct.Top+clrct.Height*0.01),clrct.Width,clrct.Height)
			Dim t As String = m_objGrid.Columns(i).HeaderText
			Dim f As Font=m_fncGetJustFont(e.Graphics,m_fntHeader,t,New SizeF(clrct.Width,clrct.Height))
			Dim sfh As New StringFormat
			Dim csh As  DataGridViewContentAlignment=m_objGrid.Columns(i).HeaderCell.Style.Alignment
			If csh=DataGridViewContentAlignment.NotSet Then
				csh=m_objGrid.ColumnHeadersDefaultCellStyle.Alignment
			End If
			sfh.LineAlignment=StringAlignment.Center
			Select Case csh
				Case DataGridViewContentAlignment.BottomLeft,DataGridViewContentAlignment.MiddleLeft,DataGridViewContentAlignment.TopLeft
					sfh.Alignment=StringAlignment.Near
				Case DataGridViewContentAlignment.BottomCenter,DataGridViewContentAlignment.MiddleCenter,DataGridViewContentAlignment.TopCenter
					sfh.Alignment=StringAlignment.Center
				Case DataGridViewContentAlignment.BottomRight,DataGridViewContentAlignment.MiddleRight,DataGridViewContentAlignment.TopRight
					sfh.Alignment=StringAlignment.Far
			End Select	
			
			With e.Graphics
				If m_blDrawColor Then
					Dim hdc As Color=m_objGrid.Columns(i).HeaderCell.Style.BackColor
					Dim hdtc As Color=m_objGrid.Columns(i).HeaderCell.Style.ForeColor
					If hdc=Color.Empty Then
						hdc=m_objGrid.ColumnHeadersDefaultCellStyle.BackColor
					End If
					If hdtc=Color.Empty Then
						hdtc=m_objGrid.ColumnHeadersDefaultCellStyle.ForeColor
					End If
					'ｶﾗｰ四角を書く
					.FillRectangle(New SolidBrush(hdc),CSng(clrct.Left),CSng(clrct.Top),CSng(clrct.Width),CSng(clrct.Height))
					'ｶﾗｰﾍｯﾀﾞ文字を書く
					.DrawString(t,f,New SolidBrush(hdtc),clrct,sfh)
				Else
					'ﾍｯﾀﾞ文字を書く
					.DrawString(t,f,Brushes.Black,txrct,sfh)
				End If
				'枠を書く
				.DrawRectangle(myPen,clrct.Left,clrct.Top,clrct.Width,txrct.Height)	
			End With
			sumx+=clrct.Width
		Next
		
		'1行分高さを消費
		sumy+=clrct.Height
		
		Do
			If m_intIndx<m_objGrid.Rows.Count Then
				Dim rh As Single=CSng(Int(m_objGrid.Rows(m_intIndx).Height*rt))
				Dim nflg As Boolean
				Dim tflg As Boolean
				If m_intIndx<m_objGrid.Rows.Count-1 AndAlso sumy+rh+CSng(Int(m_objGrid.Rows(m_intIndx+1).Height*rt))>hcnt Then
					nflg=True
				Else
					nflg=False
				End If
				If sumy+rh>hcnt Then
					e.HasMorePages=True
					Exit Do
				Else
					'各ｾﾙを印刷
					sumx=0
					For i=0 To m_objGrid.Columns.Count-1
						clrct=New RectangleF(sumx,sumy,CSng(m_objGrid.Columns(i).Width*rt),CSng(m_objGrid.Rows(m_intIndx).Height*rt))
						txrct=New RectangleF(CSng(clrct.Left+clrct.Width*0.01),CSng(clrct.Top+clrct.Height*0.01),clrct.Width,clrct.Height)
						With e.Graphics
							.PixelOffsetMode=Drawing2D.PixelOffsetMode.Half
							.SmoothingMode=Drawing2D.SmoothingMode.AntiAlias
							'四角を書く
							
							'BackColor
							If m_blDrawColor Then
								Dim cc As Color = m_objGrid.Rows(m_intIndx).Cells(i).Style.BackColor
								If cc=Color.Empty Then
									cc=m_objGrid.Rows(m_intIndx).DefaultCellStyle.BackColor
									If cc=Color.Empty Then
										cc=m_objGrid.DefaultCellStyle.BackColor
									End If
								End If
								.FillRectangle(New SolidBrush(cc),CInt(clrct.Left),CInt(clrct.Top),CInt(clrct.Width),CInt(clrct.Height))
							End If
							'１）上の線
							If m_lisJointUpperCell.Contains((i+1).ToString)=False OrElse fstrw OrElse m_intIndx=0 OrElse _
								IsNothing(m_objGrid.Rows(m_intIndx-1).Cells(i).Value) OrElse _
								IsNothing(m_objGrid.Rows(m_intIndx).Cells(i).Value) OrElse _
								m_objGrid.Rows(m_intIndx-1).Cells(i).Value.ToString<>m_objGrid.Rows(m_intIndx).Cells(i).Value.ToString Then
								.DrawLine(myPen,clrct.Left,clrct.Top,clrct.Left+clrct.Width,clrct.Top)
								tflg=True
							Else
								tflg=False
							End If
							'２）左の線
							.DrawLine(myPen,clrct.Left,clrct.Top,clrct.Left,clrct.Top+clrct.Height+CSng(0.5))
							'３）右の線
							.DrawLine(myPen,clrct.Left+clrct.Width,clrct.Top,clrct.Left+clrct.Width,clrct.Top+clrct.Height+CSng(0.5))
							'４）下の線
							If m_lisJointUpperCell.Contains((i+1).ToString)=False OrElse nflg=True OrElse m_intIndx=m_objGrid.Rows.Count-1 OrElse _
								IsNothing(m_objGrid.Rows(m_intIndx).Cells(i).Value) OrElse _
								IsNothing(m_objGrid.Rows(m_intIndx+1).Cells(i).Value) OrElse _
								m_objGrid.Rows(m_intIndx).Cells(i).Value.ToString<>m_objGrid.Rows(m_intIndx+1).Cells(i).Value.ToString Then
								.DrawLine(myPen,clrct.Left,clrct.Top+clrct.Height,clrct.Left+clrct.Width,clrct.Top+clrct.Height)						
							End If
							
							If IsNothing(m_objGrid.Rows(m_intIndx).Cells(i).Value)=False Then
								Dim t As String = m_objGrid.Rows(m_intIndx).Cells(i).Value.ToString
								Dim f As Font=m_fncGetJustFont(e.Graphics,m_fntFont,t,New SizeF(clrct.Width,clrct.Height))
								Dim sf As New StringFormat
								Dim cs As  DataGridViewContentAlignment=m_objGrid.Rows(m_intIndx).Cells(i).Style.Alignment
								If cs=DataGridViewContentAlignment.NotSet Then
									cs=m_objGrid.Columns(i).DefaultCellStyle.Alignment
								End If
								sf.LineAlignment=StringAlignment.Center
								Select Case cs
									Case DataGridViewContentAlignment.BottomLeft,DataGridViewContentAlignment.MiddleLeft,DataGridViewContentAlignment.TopLeft
										sf.Alignment=StringAlignment.Near
									Case DataGridViewContentAlignment.BottomCenter,DataGridViewContentAlignment.MiddleCenter,DataGridViewContentAlignment.TopCenter
										sf.Alignment=StringAlignment.Center
									Case DataGridViewContentAlignment.BottomRight,DataGridViewContentAlignment.MiddleRight,DataGridViewContentAlignment.TopRight
										sf.Alignment=StringAlignment.Far
								End Select
								
								'文字を書く
								If tflg Then
									'									Dim drct As New RectangleF(clrct.Left,clrct.Top+clrct.Height/2-f.SizeInPoints/2-2,clrct.Width,clrct.Height)
									If m_blDrawColor Then
										Dim ctc As Color =m_objGrid.Rows(m_intIndx).Cells(i).Style.ForeColor
										If ctc=Color.Empty Then
											ctc=m_objGrid.Rows(m_intIndx).DefaultCellStyle.ForeColor
											If ctc=Color.Empty Then
												ctc=m_objGrid.DefaultCellStyle.ForeColor
											End If
										End If
										.DrawString(t,f,New SolidBrush(ctc),txrct,sf)
									Else
										.DrawString(t,f,Brushes.Black,txrct,sf)
									End If
								End If
							End If
							
						End With
						sumx+=clrct.Width
					Next
					sumy+=clrct.Height
					m_intIndx+=1
				End If
			Else
				e.HasMorePages=False
				Exit Sub
			End If
			fstrw=False
		Loop  
		
	End Sub	
	#End Region
	#Region "その他内部関数"
	''' <summary>
	''' ﾌﾟﾘﾝﾄまたはﾌﾟﾘﾝﾀ設定を行います
	''' </summary>
	''' <param name="IsPrint">True=ﾌﾟﾘﾝﾄ False=ﾌﾟﾘﾝﾀ設定</param>
	Private Sub m_subPrint(ByVal IsPrint As Boolean,Optional Byval DocumentName As String="ﾃﾞｰﾀ表")
		Dim ps As PrinterSettings=CType(m_objPrinterDoc.PrinterSettings.Clone,PrinterSettings)
		Dim frmPrint As New PrintDialog
		frmPrint.PrinterSettings=ps
		
		If frmPrint.ShowDialog=DialogResult.OK Then
			m_objPrinterDoc.PrinterSettings=frmPrint.PrinterSettings		
			If IsPrint Then
				'ﾌﾟﾘﾝﾄに進む
				m_objPrinterDoc.DocumentName=DocumentName
				m_objPrinterDoc.Print
			Else
				'ﾌﾟﾘﾝﾀ設定だけして抜けるのでなにも処理しない
			End If
		End If
		
	End Sub
	''' <summary>
	''' 四角にぴったりｻｲｽﾞのﾌｫﾝﾄを返します
	''' </summary>
	''' <param name="g">描画対象のGraphicsｵﾌﾞｼﾞｪｸﾄ</param>
	''' <param name="basefont">ﾍﾞｰｽのﾌｫﾝﾄ</param>
	''' <param name="txt">描画予定の文字列</param>
	''' <param name="sz">描画するｴﾘｱの大きさ</param>
	''' <returns>ﾌｫﾝﾄｵﾌﾞｼﾞｪｸﾄ</returns>
	Private Function m_fncGetJustFont(Byval g As Graphics,ByVal basefont As Font,ByVal txt As String,ByVal sz As sizeF) As Font
		Dim prefferdHeight As Single = CSng(sz.Height*0.8)
		Dim f As New Font(basefont.FontFamily,prefferdHeight,GraphicsUnit.Pixel)
		Dim s As SizeF=g.MeasureString(txt,f)
		
		If s.Width < sz.Width Then
			Return f
		Else
			prefferdHeight=CSng(prefferdHeight*(sz.Width*0.98)/s.Width)
			f=New Font(basefont.FontFamily,prefferdHeight,GraphicsUnit.Pixel)
			Return f
		End If
	End Function
	
	#End Region
	#End Region
	
	#Region "ﾊﾟﾌﾞﾘｯｸｸﾗｽ"
	''' <summary>
	''' ﾕｰｻﾞｰｶｽﾀﾏｲｽﾞ用
	''' </summary>
	Public Class BeforePrintPageEventArgs
		Inherits System.Drawing.Printing.PrintPageEventArgs
		''' <summary>
		''' ｸﾞﾘｯﾄﾞﾋﾞｭｰを印刷開始する行
		''' </summary>
		Private m_sngVirticalStartPosition As Integer
		''' <summary>
		''' ｸﾞﾘｯﾄﾞﾋﾞｭｰを印刷終了する行
		''' </summary>
		Private m_sngVirticalEndPosition As Integer	
		''' <summary>
		''' ﾍﾟｰｼﾞ番号
		''' </summary>
		Private m_intPageNum As Integer
		''' <summary>
		''' ﾍﾟｰｼﾞ番号
		''' </summary>
		Public ReadOnly Property PageNum() As Integer
			Get
				Return m_intPageNum
			End Get
		End Property
		''' <summary>
		''' ｸﾞﾘｯﾄﾞﾋﾞｭｰを印刷開始する行
		''' 独自ﾍｯﾀﾞや先頭ﾍﾟｰｼﾞに表題・決済などをe.Graphicsで独自描画する場合には
		''' このｸﾗｽが重ねて表を描画しないように、この値を調整して描画開始位置を下げてください。
		''' </summary>		
		Public Property VirticalStartPosition() As Integer
			Get
				Return m_sngVirticalStartPosition
			End Get
			Set
				m_sngVirticalStartPosition = value
				If m_sngVirticalStartPosition<MyBase.MarginBounds.Top Then
					m_sngVirticalStartPosition=MyBase.MarginBounds.Top
				End If
				If m_sngVirticalStartPosition>MyBase.MarginBounds.Bottom Then
					m_sngVirticalStartPosition=MyBase.MarginBounds.Bottom
				End If
			End Set
		End Property
		
		
		''' <summary>
		''' ｸﾞﾘｯﾄﾞﾋﾞｭｰを印刷終了する行
		''' 独自ﾌｯﾀなどをe.Graphicsで独自描画する場合には
		''' このｸﾗｽが重ねて表を描画しないように、この値を調整して描画終了位置を上げてください。
		''' </summary>
		Public Property VirticalEndPosition() As Integer
			Get
				Return m_sngVirticalEndPosition
			End Get
			Set
				m_sngVirticalEndPosition = value
				If m_sngVirticalEndPosition<MyBase.MarginBounds.Top Then
					m_sngVirticalEndPosition=MyBase.MarginBounds.Top
				End If
				If m_sngVirticalEndPosition>MyBase.MarginBounds.Bottom Then
					m_sngVirticalEndPosition=MyBase.MarginBounds.Bottom
				End If
			End Set
		End Property
		
		Sub New(Byref graphics As System.Drawing.Graphics,Byref marginBounds As System.Drawing.Rectangle,Byref pageBounds As System.Drawing.Rectangle,Byref pageSetteings As System.Drawing.Printing.PageSettings,Byref pagenum As Integer)
			MyBase.New(graphics,marginBounds,pageBounds,pageSetteings)
			m_sngVirticalStartPosition=marginBounds.Top
			m_sngVirticalEndPosition=marginBounds.Bottom
			m_intPageNum=pagenum
		End Sub
		
	End Class
	#End Region	
	
End Class
